﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Net;
using Bespoke.Common;
using Bespoke.Common.Osc;

namespace MultiKinect
{
    class TcpTransmitter
    {
        private IPEndPoint Destination;
        private OscClient mOscClient;
        private int mTransmissionCount;

        public TcpTransmitter()
        {
            this.Destination = new IPEndPoint(IPAddress.Loopback, 3333);
        }

        public TcpTransmitter(IPAddress address, int port)
        {
            this.Destination = new IPEndPoint(address, port);        
        }

        public void Start()
        {
            mOscClient = new OscClient(Destination);
            try
            {
                mOscClient.Connect();
            }
            catch
            { }
        }

        public void Start(IPAddress address, int port)
        {
            this.Destination = new IPEndPoint(address, port);
            mOscClient = new OscClient(Destination);
            try
            {
                mOscClient.Connect();
            }
            catch
            {}
        }

        public void Stop()
        {
            if(isConnected())
                mOscClient.Close();
        }

        public bool SendPacket(OscPacket packet)
        {
            Assert.ParamIsNotNull(packet);
            bool success = false;
            if (mOscClient.Client.Connected)
            {
                packet.Client = mOscClient;
                try
                {
                    packet.Send();
                    mTransmissionCount++;
                    success = true;
                }
                catch (Exception ex)
                {
                    Console.WriteLine(ex.Message);
                    success = false;
                }
            }
            return success;
        }

        public bool isConnected()
        {
            if (mOscClient != null)
            {
                if (mOscClient.Client != null)
                    return mOscClient.Client.Connected;     
            }
            return false;
        }

        public int getPacketsSend()
        {
            return mTransmissionCount;
        }

        public IPEndPoint getDestination()
        {
            return this.Destination;
        }
    }
}
